<template>
  <div class="progress">
    <svg :width="width" :height="height" viewBox="0 0 100 100">
      <circle
        :cx="50"
        :cy="50"
        :r="50 - strokeWidth / 2"
        fill="transparent"
        :stroke="bgColor"
        :stroke-width="strokeWidth"
      />
      <circle
        :cx="50"
        :cy="50"
        :r="50 - strokeWidth / 2"
        fill="transparent"
        :stroke="fgColor"
        :stroke-width="strokeWidth"
        :stroke-dasharray="calcStroke"
        transform="rotate(-90,50,50)"
      />
      <text text-anchor="middle" alignment-baseline="central" x="50%" y="50%">
        <tspan dy=".3em" lengthAdjust="spacing">{{ percentDisp }}%</tspan>
      </text>
    </svg>
  </div>
</template>

<script lang="ts">
import { prop, Vue } from "vue-class-component";

class Props {
  width = prop<number>({ default: 200 });
  height = prop<number>({ default: 200 });
  bgColor = prop<string>({ default: "red" });
  fgColor = prop<string>({ default: "green" });
  strokeWidth = prop<number>({ default: 15 });
  percent = prop<number>({ default: 0 });
  decimals = prop<number>({ default: 1 });
}

export default class Progress extends Vue.with(Props) {
  get calcStroke() {
    const circ = 2 * Math.PI * (50 - this.strokeWidth / 2);
    return "" + (circ * this.percent) / 100 + " " + circ;
  }

  get percentDisp() {
    let percentDisp = this.percent;
    if (this.percent > 100) {
      percentDisp = 100;
    }
    return percentDisp.toFixed(this.decimals);
  }
}
</script>
